
code     segment
         assume    cs:code,ds:code
         org       100h

start:

; ------ schova pznaku VERIFY

         mov       ah,54h
         int       21h                      ; poskytnut VERIFY
         mov       ds:[OldVerif],al         ; schova VERIFY

; ------ zapnut VERIFY

         mov       ax,2e01h
         int       21h                      ; zapnut pznaku VERIFY

; ------ schova pvodnho aktivnho disku

         mov       ah,19h
         int       21h                      ; poskytnut aktivnho disku
         mov       ds:[olddisk],al          ; schova pvodnho aktivnho disku

; ------ pedefinovn obsluhy peruen

         mov       ax,2523h
         mov       dx,offset prerus
         int       21h                      ; pedefinovn obsluhy peruen

; ------ vpoet segmentu zatku bufferu

         mov       bx,cs                    ; aktuln segment
         add       bx,offset(konec-start+100h+15)/16 ; piten konce programu
         mov       ds:[topbuf],bx           ; segment zatku bufferu

; ------ segment konce bufferu, kontrola dostatku pamti

         mov       ax,ds:[2]                ; segment konce pamti
         sub       ax,100h                  ; rezerva pro zsobnk 4 KB
         mov       ds:[endbuf],ax           ; segment konce bufferu
         sub       ax,0f00h                 ; rezerva pro data
         cmp       ax,bx                    ; je dostatek pamti ?
         jae       start2                   ; je dostatek pamti
         mov       dx,offset memtxt         ; chyba nedostatku pamti
         jmp       chyba                    ; nen dostatek pamti

; ------ definice novho zsobnku

start2:  mov       ss,ax                    ; nov pracovn zsobnk
         xor       sp,sp                    ; pracovn vrchol zsobnku

; ------ reset diskovho systmu

         mov       ah,0dh
         int       21h                      ; reset diskovho systmu DOS

; ------ pprava textu zadn

         cld
         mov       si,81h                   ; zatek textu
         mov       di,si                    ; zatek textu
         xor       ch,ch                    ; CH <- 0
         mov       cl,ds:[80h]              ; poet znak textu
         jcxz      priprav3                 ; nen dn znak
priprav: lodsb                              ; naten znaku
         cmp       al,"a"
         jb        priprav1
         cmp       al,"z"
         ja        priprav1
         sub       al,32                    ; korekce na velk psmeno
priprav1:cmp       al,"W"                   ; je pepna "/W" ?
         jne       priprav4                 ; nen pepna "/W"
         cmp       byte ptr ds:[si-2],"/"   ; byl to parametr "/W" ?
         jne       priprav4                 ; nebyl to parametr "/W"
         mov       byte ptr ds:[overwrit],1 ; pepna - pepis bez varovn
         mov       al," "                   ; nhradn znak mezery
         mov       ds:[si-2],al             ; nhrada znaku "/"
priprav4:cmp       al,13                    ; je konec dku ?
         je        priprav3                 ; je konec dku
         cmp       al," "                   ; je platn znak ?
         jae       priprav2                 ; je platn znak
         mov       al," "                   ; nhradn mezera
priprav2:stosb                              ; uloen pekdovanho znaku
         loop      priprav                  ; pprava dalho znaku
priprav3:xor       al,al
         stosb                              ; oznaen konce textu

; ------ rozlien prvnho parametru (zda je disk)

         mov       si,81h                   ; zatek textu
         call      disk                     ; naten oznacen disku
         jc        souborx                  ; nen disk - bude soubor
         call      disk5                    ; test sla disku
         mov       dx,offset disktxt        ; chyba zadn disku
         jc        chyba                    ; chybn zadn sla disku

; ------ druhm parametrem bude soubor

         call      soubor                   ; rozbor zadn jmna souboru
         mov       dx,offset errtxt
         jc        chyba                    ; chyba zadn

; ------ vytvoen clovho souboru pro zpis

         mov       dx,di                    ; jmno souboru
         cmp       byte ptr ds:[overwrit],1 ; potvrzen zpisu ?
         je        soubex1                  ; soubor se me pepsat
         mov       ah,4eh
         mov       cx,17h
         int       21h                      ; test, zda soubor existuje
         jnc       soubex                   ; soubor nalezen - chyba
soubex1: xor       cx,cx
         mov       ah,3ch
         int       21h                      ; vytvoen souboru
         mov       dx,offset zadtxt
         jc        chyba                    ; chybn zadn souboru
         mov       word ptr ds:[identif],ax ; identifiktor souboru

         call      copdf                    ; koprovn z disku do souboru
         jc        chyba                    ; chyba operace

navrat:  push      cs
         pop       es
         push      cs
         pop       ds
         mov       al," "
         mov       cx,22
         cld
         mov       di,offset kurz
         mov       dx,di
         rep       stosb
         call      disptxt
         xor       al,al
         jmp       short chyba1

soubex:  mov       dx,offset existtxt
chyba:   push      cs
         pop       ds
         call      disptxt                  ; zobrazen chybovho textu
prerus:  mov       al,1                     ; nvratov kd

chyba1:  push      cs
         pop       ds
         push      ax
         mov       bx,ds:[identif]
         or        bx,bx
         jz        chyba2
         mov       ah,3eh
         int       21h
chyba2:  mov       dl,ds:[olddisk]
         mov       ah,0eh
         int       21h                      ; nvrat pvodnho disku

; ------ nvrat VERIFY

         mov       al,ds:[OldVerif]         ; pvodn pznak VERIFY
         mov       ah,2eh
         int       21h                      ; nvrat pznaku VERIFY

         pop       ax

         mov       ah,4ch
         int       21h                      ; ukonen s chybou

; ------ prvnm parametrem je asi soubor (nen to disk)

souborx: mov       si,81h                   ; zatek textu
         call      soubor                   ; rozbor zadn jmna souboru
         mov       dx,offset errtxt
         jc        chyba                    ; chyba zadn

; ------ oteven zdrojovho souboru

         mov       dx,di                    ; jmno souboru
         mov       ax,3d00h
         int       21h                      ; oteven souboru pro ten
         mov       dx,offset fndtxt
         jc        chyba                    ; chyba - soubor nenalezen
         mov       word ptr ds:[identif],ax ; identifiktor souboru

; ------ druhm parametrem m bt disk

         call      disk                     ; naten oznacen disku
         mov       dx,offset errtxt
         jc        chyba                    ; nen disk - chyba
         call      disk5                    ; test sla disku
         mov       dx,offset disktxt        ; chyba zadn disku
         jc        chyba                    ; chybn zadn sla disku

; ------ koprovn souboru na disk

         call      copfd                    ; koprovn ze souboru na disk
         jc        chyba                    ; chyba operace
         jmp       short navrat


; =============================================================================

copdf89: ret


                                         ;* koprovn disku do souboru
copdf:
         call      pardisk                  ; nastaven parametr disku
         jc        copdf89                  ; nekompatibiln systm

; ------ naten sektor z disku do cel pamti

; ------ nastaven ukazatel na zatek bufferu

copdf1:  mov       ax,ds:[readsekt]         ; ukazatel sektor ke ten
         mov       ds:[frstsekt],ax         ; schova prvnho sektoru
         mov       ax,ds:[topbuf]           ; zatek bufferu
         mov       ds:[readseg],ax          ; tec adresa

; ------ vpoet potu sektor pro jednu operaci ten

copdf22: mov       ax,ds:[endbuf]           ; konec pamti
         sub       ax,ds:[readseg]          ; vpoet velikosti voln pamti
         xor       dx,dx
         div       word ptr ds:[sektsiz4]   ; vpoet potu sektor
         mov       cx,ax                    ; poet sektor
         cmp       cx,ds:[bufsekt]          ; max. poet sektor pro operaci
         jbe       copdf23                  ; poet sektor OK
         mov       cx,ds:[bufsekt]          ; omezen sektor na 64 KB
copdf23: mov       ax,ds:[maxsekt]          ; maximln poet sektor na disku
         sub       ax,ds:[readsekt]         ; poet zbylch sektor
         cmp       ax,cx                    ; zbv mn sektor ?
         jae       copdf3                   ; poadovan poet sektor men
         mov       cx,ax                    ; omezen na sektory do konce disku

; ------ naten bloku sektor (max. 64 KB) do pamti

copdf3:  clc
         jcxz      copdf33                  ; je ji konec pamti
         mov       dx,ds:[readsekt]
         mov       bx,ds:[readseg]
         call      readskt                  ; naten bloku dat do pamti
         mov       dx,offset readdtxt
         jc        copdf89                  ; chyba ten z diskety
         add       ds:[readsekt],cx         ; zven ukazatele sektor
         mov       ax,ds:[sektsiz4]         ; velikost sektoru
         mul       cx                       ; vpoet prustku adresy
         add       ds:[readseg],ax          ; zven ukldac adresy

; ------ zobrazen kurzoru

         call      dispkurr                 ; zobrazen kurzoru pro ten

; ------ test, zda je ji konec pamti

         cmp       bx,ds:[endbuf]           ; je ji konec pamti ?
         jb        copdf22                  ; nen jet konec pamti

; ------ nastaven ukazatel na zatek bufferu

copdf33: mov       ax,ds:[topbuf]           ; zatek bufferu
         mov       ds:[writseg],ax          ; zposov adresa

copdf34:

         push      bx
         push      ds

         mov       ax,ds:[readsekt]         ; posledn naten sektor
         sub       ax,ds:[writsekt]         ; poet zbylch sektor pro zpis
         cmp       ax,ds:[bufsekt]          ; je velk poet sektor ?
         jbe       copdf35                  ; poet sektor je OK
         mov       ax,ds:[bufsekt]          ; omezen potu sektor
copdf35: add       ds:[writsekt],ax         ; zven ukazatele sektor
         mul       word ptr ds:[sektsize]   ; pepoet na bajty
         mov       cx,ax                    ; poet bajt k zpisu

         mov       ds,ds:[writseg]          ; adresa pro zpis
         xor       dx,dx                    ; offset adresy
         mov       bx,cs:[identif]
         mov       ah,40h
         clc
         jcxz      copdf36
         int       21h                      ; zpis dat do souboru
copdf36:
         pop       ds
         pop       bx
         jcxz      copdf5

         jc        copdf6
         cmp       ax,cx
         jne       copdf6

         shr       cx,1
         shr       cx,1
         shr       cx,1
         shr       cx,1
         add       ds:[writseg],cx          ; zven zpisovho segmentu

; ------ zobrazen kurzoru

         call      dispkurw                 ; zobrazen kurzoru pro zpis

         mov       ax,ds:[writseg]
         cmp       ax,ds:[endbuf]
         jb        copdf34                  ; zpis dalho bloku

copdf5:  mov       ax,ds:[readsekt]
         cmp       ax,ds:[maxsekt]
         jae       copdf9
         jmp       copdf1


copdf6:  mov       dx,offset writftxt
         stc
         ret

copdf7:  mov       dx,offset readdtxt
copdf8:  stc
copdf9:  ret



                                           ;* koprovn souboru na disk
copfd:
         mov       al,ds:[disket]
         add       al,"A"
         mov       ds:[vartxt1],al
         mov       dx,offset vartxt
         cmp       byte ptr ds:[overwrit],1 ; potvrzen zpisu ?
         je        copfd0                   ; zpis se nepotvrzuje
         call      disptxt                  ; zobrazen textu varovn
         mov       ax,0c01h
         int       21h                      ; vstup znaku z klvesnice
         push      ax
         mov       dx,offset systxt1
         call      disptxt                  ; oddkovn textu
         pop       ax
         cmp       al,13                    ; je Enter ?
         je        copfd0                   ; je Enter - pokraovn operace

         stc ; clc
copfda:  ret

copfd0:

         call      pardisk                  ; nastaven parametr disku
         jc        copfda                   ; nekompatibiln systm

                                          ;* zjitn velikosti souboru
         mov       bx,ds:[identif]
         mov       ax,4202h
         xor       cx,cx
         xor       dx,dx
         int       21h
         div       word ptr ds:[sektsize]   ; vpoet potu sektor
         cmp       ds:[maxsekt],ax          ; kontrola potu sektor disku
         mov       dx,offset formtxt
         stc
         jne       copfda                   ; chyba - nesprvn formt disku
         xor       cx,cx
         xor       dx,dx
         mov       ax,4200h
         int       21h

; ------ nastaven ukazatel na zatek bufferu

copfd1:  mov       ax,ds:[readsekt]         ; ukazatel sektor ke ten
         mov       ds:[frstsekt],ax         ; schova prvnho sektoru
         mov       ax,ds:[topbuf]           ; zatek bufferu
         mov       ds:[readseg],ax          ; tec adresa

; ------ vpoet potu sektor pro jednu operaci ten

copfd22: mov       ax,ds:[endbuf]           ; konec pamti
         sub       ax,ds:[readseg]          ; vpoet velikosti voln pamti
         xor       dx,dx
         div       word ptr ds:[sektsiz4]   ; vpoet potu sektor
         mov       cx,ax                    ; poet sektor
         cmp       cx,ds:[bufsekt]          ; max. poet sektor pro operaci
         jbe       copfd23                  ; poet sektor OK
         mov       cx,ds:[bufsekt]          ; omezen sektor na 64 KB
copfd23: mov       ax,ds:[sektsize]         ; velikost sektoru
         mul       cx                       ; pepoet sektor na bajty
         mov       cx,ax                    ; poet bajt ke ten

; ------ naten bloku sektor ze souboru

         clc
         jcxz      copfd33                  ; je ji konec pamti
         push      ds
         mov       bx,ds:[identif]
         mov       ds,ds:[readseg]          ; segment ke ten dat
         xor       dx,dx                    ; offset adresy
         mov       ah,3fh
         int       21h                      ; ten dat ze souboru
         pop       ds
         mov       dx,offset readftxt
         jc        copfda                   ; chyba ten
         push      ax
         xor       dx,dx
         div       word ptr ds:[sektsize]   ; vpoet potu sektor
         add       ds:[readsekt],ax         ; zven ukazatele tenho sektoru
         pop       ax

         call      dispkurr                 ; zobrazen kurzoru pro ten

         mov       cl,4
         shr       ax,cl                    ; pevod natench dat na odstavce
         add       ds:[readseg],ax          ; zven adresy tench dat
         or        ax,ax
         jz        copfd33                  ; je konec souboru
         mov       ax,ds:[endbuf]
         cmp       ax,ds:[readseg]
         ja        copfd22                  ; dal blok dat

; ------ zpis sektor na disk

copfd33: mov       ax,ds:[topbuf]           ; zatek bufferu
         mov       ds:[writseg],ax          ; zposov adresa
         mov       ax,ds:[readsekt]
         cmp       ax,ds:[writsekt]
         je        copfdb                   ; jsou ji vechny sektory

; ------ zpis 64 KB na disk

copfd34:
         mov       ax,ds:[readsekt]         ; posledn naten sektor
         sub       ax,ds:[writsekt]         ; poet zbylch sektor pro zpis
         cmp       ax,ds:[bufsekt]          ; je velk poet sektor ?
         jbe       copfd35                  ; poet sektor je OK
         mov       ax,ds:[bufsekt]          ; omezen potu sektor
copfd35: mov       cx,ax                    ; poet sektor pro zpis
         jcxz      copfd36                  ; jsou ji vechna data

         mov       dx,ds:[writsekt]
         mov       bx,ds:[writseg]
         add       ds:[writsekt],cx         ; zven ukazatele sektor

         call      writskt                  ; zpis sektor na disk
         jc        copfd6                   ; chyba zpisu na disk

         mov       ax,ds:[sektsiz4]
         mul       cx                       ; prustek adresy v odstavcch
         add       ds:[writseg],ax          ; zven adresy


copfd36:
         call      dispkurw                 ; zobrazen kurzoru pro zpis

         mov       ax,ds:[writsekt]
         cmp       ax,ds:[readsekt]
         jb        copfd34                  ; zpis dalho bloku

copfd5:
         jmp       copfd1

copfd6:  mov       dx,offset writdtxt
         stc
copfdb:  ret


; =============================================================================

                                          ;* naten parametru - oznaen disku
disk:
         call      readspc                  ; vypustn mezer
         jc        disk1                    ; nen dn parametr

; ------ rozlien, zda je parametrem zadn disku

         cmp       byte ptr ds:[si+1],":"   ; je zadn disk ?
         jne       disk1                    ; nen zadn disk
         cmp       byte ptr ds:[si+2]," "   ; je platn znak ?
         ja        disk1                    ; je platn znak - nen disk
         call      readch                   ; naten oznaen disku
         sub       al,"A"                   ; korekce na slo disku
         mov       ds:[disket],al           ; schova oznaen disku
         inc       si                       ; peskoen znaku ":"
         clc
         ret

disk1:   stc
         ret

; ------ test, zda je zadna existujc mechanika

disk5:
         mov       dl,ds:[disket]           ; zadan disk
         mov       ah,0eh
         int       21h
         mov       ah,19h
         int       21h
         cmp       al,ds:[disket]           ; je slo diskety OK ?
         je        disk4
         stc
disk4:   pushf
         mov       ah,0eh
         mov       dl,ds:[OldDisk]
         int       21h
         popf
         ret



                                          ;* nastaven oznaen souboru
soubor:

; ------ nalezen zatku druhho parametru

         call      readspc                  ; vypustn mezer
         jc        soubor5                  ; chyba zadn - nen parametr

; ------ test, zda je zadno oznaen disku

         cmp       byte ptr ds:[si+1],":"   ; je oznaen disku ?
         jne       soubor2                  ; nen oznaen disku
         cmp       byte ptr ds:[si+2]," "+1 ; je dle njak platn znak ?
         jb        soubor5                  ; je zadn jen disk

; ------ oznaen konce jmna souboru

soubor2: mov       di,si                    ; schova zatku jmna souboru
soubor3: call      readch
         jc        soubor4                  ; konec textu
         jne       soubor3                  ; nen konec textu
         mov       byte ptr ds:[si-1],0     ; oznaen konce jmna souboru

soubor4: clc
soubor5: ret



                                          ;* naten sektor do pamti
                                            ; VSTUP: CX=poet sektor
                                            ;        DX=poten sektor
                                            ;        BX=segment adresy
readskt:
         mov       bp,4                     ; poet pokus

readsek1:dec       bp
         stc
         jz        readsek2                 ; chyba

         push      bp
         push      ax
         push      bx
         push      cx
         push      dx
         push      ds

         mov       ds,bx
         xor       bx,bx

         mov       al,cs:[disket]

         mov       cs:[zasobnik],sp
         int       25h
         mov       sp,cs:[zasobnik]

         pop       ds
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         pop       bp
         jc        readsek1

readsek2:ret


                                          ;* zpis sektor na disk
                                            ; VSTUP: CX=poet sektor
                                            ;        DX=poten sektor
                                            ;        BX=segment adresy
writskt:
         mov       bp,4                     ; poet pokus

writsek1:dec       bp
         stc
         jz        writsek2                 ; chyba

         push      bp
         push      ax
         push      bx
         push      cx
         push      dx
         push      ds

         mov       ds,bx
         xor       bx,bx

         mov       al,cs:[disket]

         mov       cs:[zasobnik],sp
         int       26h
         mov       sp,cs:[zasobnik]

         pop       ds
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         pop       bp
         jc        writsek1

writsek2:ret




                                          ;* zjitn parametr disku
pardisk:

         mov       dx,offset kurz
         call      disptxt

; ------ naten prvnho sektoru z diskety

         mov       cx,1                     ; 1 sektor
         xor       dx,dx                    ;
         mov       bx,ds:[topbuf]
         call      readskt                  ; naten BOOT sektoru
         mov       dx,offset readdtxt
         jc        pardisk2                 ; chyba ten zavade z diskety

; ------ uren velikosti disku

         call      InitINT25                ; inicializace parametr disku
         mov       dx,offset systtxt
         jc        pardisk2                 ; chyba disku

; ------ vpoet maximlnho potu sektor pro jednu operaci

         mov       ax,0ffffh
         xor       dx,dx                    ; maximln velikost 64 KB - 1
         div       word ptr ds:[Sektsize]   ; vpoet potu sektor
         mov       ds:[bufsekt],ax          ; poet sektor do 64 KB

         clc

pardisk2:ret




public   InitINT25
InitINT25:                                ;* inicializace obsluhy INT 25h

         push      ds
                                          ;* poskytnut tabulky parametr disku
         mov       dl,cs:[disket]           ; disk pro obsluhu INT 25h
         inc       dl
         mov       ax,32ffh
         int       21h                      ; poskytnut bloku parametr disku

                                          ;* test sprvnosti disku
         cmp       al,0ffh                  ; je chyba ?
         stc
         je        InitI255                 ; je chyba - neplatn disk
         dec       dl                       ; slo poadovanho disku
         cmp       dl,ds:[bx]               ; souhlas slo disku ?
         stc
         jne       InitI255                 ; slo disku nesouhlas - chyba

                                          ;* zjitn celkovho potu sektor
         mov       ax,ds:[bx+0dh]           ; max. slo alokanho bloku
         dec       ax                       ; poet alokanch blok
         xor       cx,cx                    ; CX <- 0
         mov       cl,ds:[bx+4]             ; maximln slo sektoru v bloku
         inc       cx                       ; poet sektor v alokanm bloku
         mul       cx                       ; vpoet potu sektor dat celkem
         add       ax,ds:[bx+0bh]           ; piten rezervovanch sektor
         jc        InitI255                 ; velk poet sektor
         or        dx,dx
         stc
         jnz       InitI255                 ; velk poet sektor

         mov       word ptr cs:[maxsekt],ax ; poet sektor disku celkem
         cmp       ax,128                   ; minimln poet sektor
         jb        InitI255                 ; chybn poet sektor
         cmp       ax,4000h                 ; maximln velikost zejm 8 MB
         cmc
         jc        InitI255                 ; chybn poet sektor

         mov       ax,ds:[bx+2]             ; poet bajt na sektor
         mov       cs:[Sektsize],ax         ; velikost sektoru
         cmp       ax,64
         jb        InitI255
         cmp       ax,4000h
         cmc
         jc        InitI255
         test      ax,63                    ; nsobek 2 ?
         stc
         jnz       initi255                 ; chybn velikost
         mov       cl,4
         shr       ax,cl                    ; pevod na odstavce
         mov       cs:[sektsiz4],ax         ; poet odstavc na sektor

         clc

InitI255:pop       ds
         ret


dispkurr:                                 ;* zobrazen kurzoru pro ten

         push      ax
         push      cx
         mov       al,176
         mov       cx,cs:[readsekt]
         call      dispkur
         pop       cx
         pop       ax
         ret

dispkurw:                                 ;* zobrazen kurzoru pro zpis

         push      ax
         push      cx
         mov       al,178
         mov       cx,cs:[writsekt]
         call      dispkur
         pop       cx
         pop       ax
         ret



                                          ;* zobrazen kurzoru
                                            ; VSTUP: CX=aktuln sektor
                                            ;        AL=znak kurzoru

dispkur: push      ax
         push      cx
         push      dx
         push      si

         push      ax
         mov       ax,cx                    ; nov kurzor
         call      pozkur                   ; vpoet pozice
         mov       cx,si                    ; schova pozice
         mov       ax,cs:[frstsekt]         ; star kurzor
         call      pozkur
         sub       cx,si                    ; prustek pozic
         pop       ax
         jcxz      dispkur3
dispkur2:mov       ds:[si],al
         inc       si
         loop      dispkur2

         mov       dx,offset kurz
         call      disptxt

dispkur3:pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

                                          ;* vpoet pozice kurzoru
                                            ; VSTUP: AX=slo sektoru
                                            ; VSTUP:SI=adresa kurzoru
pozkur:  push      ax
         push      cx
         push      dx

         mov       cx,20                    ; poet znak
         mul       cx                       ; vynsoben 20x
         mov       cx,cs:[maxsekt]          ; celkov poet sektor
         div       cx                       ; vpoet offsetu kurzoru
         mov       si,ax                    ; offset kurzoru
         add       si,offset kurz+1         ; adresa kurzoru

         pop       dx
         pop       cx
         pop       ax
         ret


; =============================================================================



readspc: call      readch
         jc        readspc2
         je        readspc
         dec       si
readspc2:ret


readch:  lodsb                              ; naten znaku
         cmp       al," "                   ; rozlien oddlovae, konce
         jae       readch2                  ; nen konec textu
         dec       si                       ; nvrat poslednho znaku
readch2: ret




disptxt: push      ax
         mov       ah,9
         int       21h
         pop       ax
         ret

; =============================================================================

errtxt   db        'DISKFILE V1.11 - kopirovani disket; (c) Miroslav Nemecek',13,10
         db        '--------------------------------------------------------',13,10
         db        'Zadejte: DISKFILE  zdrojovy_disk:   cilovy_soubor',13,10
         db        '   nebo: DISKFILE  zdrojovy_soubor  cilovy_disk:',13,10
         db        '/W - cilovy soubor nebo disk se prepise bez varovani',13,10
         db        '$'

memtxt   db        'Nedostatek pameti !',13,10,'$'
fndtxt   db        'Zdrojovy soubor nenalezen !',13,10,'$'
zadtxt   db        'Chybne zadani jmena souboru !',13,10,'$'
disktxt  db        'Chybne zadani disketove jednotky !',13,10,'$'
readftxt db        'Chyba cteni ze zdrojoveho souboru !',13,10,'$'
writftxt db        'Chyba zapisu do ciloveho souboru !',13,10,'$'
readdtxt db        'Chyba cteni z diskety !',13,10,'$'
writdtxt db        'Chyba zapisu na disketu !',13,10,'$'
existtxt db        'Cilovy soubor jiz existuje !',13,10,'$'
systtxt  db        'Chyba systemu nebo nezformatovany disk !'
systxt1: db        13,10,'$'
vartxt   db        '< Vlozte novou disketu do mechaniky  '
vartxt1  db        'A: >Ŀ',13,10
         db        ' VAROVANI: vechna data na disku budou znicena ! ',13,10
         db        ' Enter=pokracovani, jina klavesa=preruseni $'
formtxt  db        'Nespravny format ciloveho disku !',13,10,'$'

kurz     db        '> . . . . . . . . .  <',13,'$'

overwrit db        0                        ; pznak: 1=pepis bez varovn
frstsekt dw        0                        ; prvn sektor v pamti
readsekt dw        0                        ; ukazatel tench sektor
writsekt dw        0                        ; ukazatel zapisovanch sektor
readseg  dw        0                        ; tec adresa
writseg  dw        0                        ; zpisov adresa
lastsekt dw        0                        ; posledn sektor v pamti + 1

maxsekt  dw        0                        ; celkov poet sektor disku
sektsize dw        0                        ; poet bajt na sektor
sektsiz4 dw        0                        ; velikost sektoru v odstacch
bufsekt  dw        0                        ; maximln poet sektor do 64 KB

olddisk  db        0                        ; schova pvodnho aktivnho disku
zasobnik dw        0                        ; schova ukazatele zsobnku
disket   db        0                        ; disketov jednotka
identif  dw        0                        ; identifiktor souboru

topbuf   dw        0                        ; segment zatku bufferu
endbuf   dw        0                        ; segment konce bufferu

OldVerif db        0                        ; uschovan pznak VERIFY

konec    label     byte                     ; konec programu

code     ends
         end       start
